/**
 *     This file is part of the Squashtest platform.
 *     Copyright (C) Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
/* You can add global styles to this file, and also import other style files */
@import "ng-zorro-theme";
@import "ng-zorro-override";

/* soft reset */
html,
body,
textarea,
figure,
label {
  margin: 0;
  padding: 0;
}

/* Roboto font initialization */
/* Regular + Medium (font-weight: 300;) */
@font-face {
  font-family: "Roboto";
  src: url('fonts/Roboto/Roboto-Regular.ttf');
}

@font-face {
  font-family: "Roboto";
  font-weight: bold;
  src: url('fonts/Roboto/Roboto-Bold.ttf');
}

@font-face {
  font-family: "Roboto";
  font-style: italic;
  src: url('fonts/Roboto/Roboto-Italic.ttf');
}

@font-face {
  font-family: "Roboto";
  font-weight: bold;
  font-style: italic;
  src: url('fonts/Roboto/Roboto-BoldItalic.ttf');
}

@font-face {
  font-family: "Roboto";
  font-weight: 300;
  src: url('fonts/Roboto/Roboto-Medium.ttf');
}

@font-face {
  font-family: "Roboto";
  font-weight: 300;
  font-style: italic;
  src: url('fonts/Roboto/Roboto-MediumItalic.ttf');
}

/* border-box everywhere, it's simple, more than using it partially */
/* height 100% seems to be mandatory to lock body size to 100% also*/
/* overflow hidden because only page content is scrollable, the outer frame is not*/
html {
  height: 100%;
  box-sizing: border-box;
  font-family: "Segoe UI", "Roboto", serif;
}

/* locking body size to 100% */
body {
  min-height: 100% !important;
  height: 100% !important;
  overflow: hidden;
}


*, *:before, *:after {
  box-sizing: inherit;
}

// base border from ngZorro theme plugged into class for reuse in custom component
:root {
  --base-border-radius: @border-radius-base;
  --warning-color: @warning-color;
  --error-color: @warning-color;
}

/* class used to measure scroll bar by creating a div way the hell off screen */
.scrollbar-measure {
  width: 100px;
  height: 100px;
  overflow: scroll;
  position: absolute;
  top: -9999px;
}

.position-relative {
  position: relative;
}

.justify-content-flex-end {
  justify-content: flex-end;
}

.justify-content-space-evenly {
  justify-content: space-evenly;
}

.justify-content-center {
  justify-content: center;
}

.justify-content-space-between {
  justify-content: space-between;
}

.full-height {
  height: 100%;
  min-height: 0;
}

.full-width {
  width: 100%;
}

.overflow-hidden {
  overflow: hidden;
}

.flex {
  display: flex;
}

.flex-row {
  display: flex;
  flex-wrap: nowrap;
}

.flex-column {
  display: flex;
  flex-direction: column;
  flex-wrap: nowrap;
}

.flex-fixed-size {
  flex-grow: 0;
  flex-shrink: 0;
}

.flex-grow-shrink {
  flex-grow: 1;
  flex-shrink: 1;
}

.svg-white {
  fill: white;
}

.svg-black {
  fill: black;
}

.__hover_label_color:hover {
  background-color: var(--label-color);
}

.__hover_background_color:hover {
  background-color: var(--background-color);
}

.__hover_current_ws_border:hover {
  border-color: var(--current-workspace-main-color) !important;
}

.__hover_pointer:hover {
  cursor: pointer;
}

.__hover_grab:hover {
  cursor: grab;
}

.__hover_default:hover {
  cursor: default;
}

.__hover_text:hover {
  cursor: text;
}

.__hover_col_resize {
  cursor: col-resize;
}

.current-workspace-button {
  color: var(--current-workspace-main-color);
  cursor: pointer;

  &:hover {
    color: var(--current-workspace-brightest-color);
  }
}

.current-workspace-svg-color__hover:hover svg {
  fill: var(--current-workspace-main-color);
  cursor: pointer;
}

.current-workspace-text-color__hover:hover {
  color: var(--current-workspace-main-color);
  cursor: pointer;
}

.current-workspace-main-color {
  color: var(--current-workspace-main-color);
}

.current-workspace-border-color {
  border-color: var(--current-workspace-main-color) !important;
}

.nav-bar-background-color {
  background-color: var(--nav-main-color);
}

.nav-bar-width {
  max-width: 180px;
}

.container-border {
  border: solid 1px var(--container-border-color);
  border-radius: 5px;
}

.container-border-color {
  border-color: var(--container-background-color);
}

.container-transparent-border {
  border: solid 1px transparent;
  border-radius: 5px;
}

// Class to apply the current workspace main color as background color.
.current-workspace-background-color {
  background-color: var(--current-workspace-background-color);
}

// Class to apply the neutral grey as background color.
.neutral-background-color {
  background-color: var(--background-color);
}

// Class to apply the container background as background color
.container-background-color {
  background-color: var(--container-background-color);
}


.sqtm-core-prevent-selection {
  user-select: none;
}

.sqtm-core-prevent-selection-in-grid {
  .sqtm-core-prevent-selection {
    .sqtm-grid-std-layout {
      sqtm-core-grid-cell>div {
        user-select: none !important;
      }
    }
  }
}

.anchor {
  position: relative;
  /*top: -385px;*/
}

.txt-ellipsis {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

.txt-ellipsis-rtl {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  direction: rtl;
}

.font-family-monospace {
  font-family: Consolas, Menlo, Monaco, Lucida Console, Liberation Mono, DejaVu Sans Mono, Bitstream Vera Sans Mono, Courier New, monospace, serif;
}

.label-color, .header-color, .sqtm-placeholder {
  color: var(--label-color);
}

.field-value-color {
  color: var(--user-value-color)
}

.sqtm-core-error-message {
  color: #ff1719;
}

.sqtm-core-warning-message {
  color: #FAAD14;
}

.content-head {
  margin-bottom: 28px;

  .reference {
    font-size: 16px;
    font-weight: 600;
  }
}

.side-bar {
  overflow: auto;

  .anchor-bar {
    position: relative;
    left: 0;
    line-height: 1;

    .anchor-group {
      margin-bottom: 20px;
      border: 1px solid var(--container-border-color);
      border-radius: 0 5px 5px 0;

      .anchor-link {
        border-radius: 0 5px 5px 0;
      }
    }

    sqtm-core-anchor-group div sqtm-core-anchor-link:first-child .container {
      border-radius: 0 5px 0 0;
    }

    sqtm-core-anchor-group div sqtm-core-anchor-link:last-child .container {
      border-radius: 0 0 5px 0;
    }

    sqtm-core-anchor-group div sqtm-core-anchor-link:only-child .container {
      border-radius: 0 5px 5px 0;
    }

    .anchor-group-selected {
      box-shadow: 2px 2px 3px #d0dae0;
    }

    .container {
      &:only-child {
        border-radius: 0 5px 5px 0;
      }

      color: #666666;
      text-align: center;
      height: 40px;
      width: 40px;
      display: table-cell;
      vertical-align: middle;
      // Use this property to avoid the blue border when clicking on it with Chrome
      outline: none;

      &-active {
        color: var(--current-workspace-main-color);
        background-color: var(--container-background-color);
      }

      &-inative {
        background-color: transparent;
      }

      &:hover {
        background-color: var(--container-background-color);
      }
    }
  }
}

.anchor-counter {
  height: 15px;
  width: 15px;
  background-color: var(--container-background-color);
  font-size: 10px;
  display: block;
  margin: auto;
}

.admin-workspace-anchor-icon {
  font-size: 20px;
}

.entity-view-collapse-panel {
  &-title {
    color: var(--current-workspace-main-color);
    display: inline;
  }

  nz-collapse-panel {
    margin-bottom: 28px;
  }
}

.two-cols-form {
  display: grid;
  grid-template-columns: 1fr 5fr;
  grid-template-rows: auto;
  grid-column-gap: 10px;
  grid-row-gap: 8px;

  .label {
    color: var(--label-color);
    font-size: 14px;
    margin: 5px 0;

    &__align_right {
      text-align: right;
    }
  }
}

.four-cols-form {
  display: grid;
  grid-template-columns: 1fr 2fr 1fr minmax(0, 3fr);
  grid-template-rows: auto;
  grid-column-gap: 5px;
  grid-row-gap: 5px;
  overflow: hidden;

  .label {
    color: var(--label-color);
    font-size: 14px;
    margin: 5px 0;

    &__align_right {
      text-align: right;
    }
  }
}

.folder-information-grid {
    display: grid;
    grid-template-columns: 1fr minmax(0, 5fr);
    grid-column-gap: 10px;
    grid-row-gap: 10px;
    align-items: center;
}

.entity-information-grid {
  display: grid;
  grid-template-columns: 1fr 2fr 1fr 2fr;
  grid-column-gap: 1%;
  grid-row-gap: 10px;
  align-items: center;
}

.entity-information-grid-one-column {
  display: grid;
  grid-template-columns: 1fr 5fr;
  grid-column-gap: 1%;
  grid-row-gap: 10px;
  align-items: center;
}

.grid-column-start-1 {
  grid-column-start: 1;
}

.grid-column-start-2 {
  grid-column-start: 2;

}

.sqtm-core-screen-title {
  font-size: 20px;
  font-weight: 600;
  color: var(--current-workspace-main-color);
}

.sqtm-core-dialog-divider {
  color: var(--container-border-color);
  height: 2px;
  margin: 5px 0;
}

.sqtm-core-delete-button {
  background-color: rgba(255, 0, 0, 0.62);
  border-width: 0;
  text-shadow: none;

  &:hover {
    background-color: rgba(255, 0, 0, 0.72);
  }
}

.txt__semi-bold {
  font-weight: 500;
}

.rotate-90 svg {
  transform: rotate(90deg);
}

.rotate-180 svg {
  transform: rotate(180deg);
}

.transparent-overlay-backdrop {
  background-color: rgba(255, 255, 255, 0);
}

.sqtm-dialog-container {
  width: 100%;
}

.sqtm-overlay {
  &__background {
    background-color: var(--container-background-color);
  }

  &-border {
    border-radius: 5px;
    border: solid 1px var(--container-border-color);
    box-shadow: 1px 1px 1px 1px rgba(0, 0, 0, 0.1);
  }
}

.sqtm-large-grid-container-title {
  font-weight: 600;
  font-size: 18px;
  color: var(--current-workspace-main-color);
}

.sqtm-large-grid-container {
  border: 1px solid var(--container-border-color);
  background-color: var(--container-background-color);
  border-radius: 5px;
}

.sqtm-tree-configuration-title {
  font-weight: 600;
  font-size: 14px;
  color: var(--current-workspace-main-color);
}

.sqtm-core-two-column-information-display {
  display: grid;
  grid-template-columns: max-content auto;
  grid-template-rows: auto;
  grid-column-gap: 20px;
  grid-row-gap: 8px;

  .label {
    color: var(--label-color);
    font-size: 14px;
  }
}

.sqtm-core-drop-zone {
  border-color: var(--current-workspace-main-color) !important;
  background-color: #0f74a8;
}

.sqtm-core-border-current-workspace-color {
  border: solid 1px var(--current-workspace-main-color);
}

.sqtm-core-dialog-form {
  display: grid;
  grid-template-columns: max-content auto;
  grid-template-rows: auto;
  grid-column-gap: 10px;
  grid-row-gap: 8px;

  .label {
    color: var(--label-color);
    font-size: 14px;
    margin: 5px 0;

    &__align_right {
      text-align: right;
    }
  }
}

.disabled-row {
  font-style: italic;
  color: var(--label-color);
}

.sqtm-core-hovered-row {
  background-color: var(--current-workspace-hovered-row-color);
}

.sqtm-core-infolist-icon {
  color: #666666
}

.remove-chrome-router-link-border:focus {
  outline: unset;
}

.admin-workspace-main-title {
  display: block;
  font-size: 20px;
  font-weight: 600;
  color: var(--current-workspace-main-color);
  margin-top: 8px;
}

.admin-workspace-secondary-title {
  display: block;
  font-size: 18px;
  font-weight: 600;
  color: var(--current-workspace-main-color);
  margin-bottom: 10px;
  flex-grow: 1;
}

.admin-workspace-grid {
  overflow: hidden;
  width: 100%;
  height: 100%;
  display: block;
}

.admin-workspace-grid-toolbar {
  margin: 8px 0 8px 20px;
  font-size: 18px;

  i {
    margin: 0 6px;
  }
}

.admin-view-panel-buttons {
  display: flex;
  flex-wrap: nowrap;
}

.admin-view-panel-buttons > * {
  padding: 0 5px;
}


.admin-workspace-grid-container {
  padding: 10px 10px 10px 0;
}

.admin-contextual-content-close-button {
  margin-top: 4px;
  display: block;
}

.admin-contextual-content-body {
  overflow-y: hidden;
  border: solid 1px var(--background-color);
  height: 100%;
  padding-left: 18px;
}

.tree-icon-size {
  font-size: 16px;
}

.table-icon-size {
  font-size: 18px;
}

.navigation-icon-size {
  font-size: 20px;
}

.action-icon-size {
  font-size: 22px;
}

.icon-container {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}

.sqtm-core-capsule {
  width: 100%;
  background-color: white;
  border-color: var(--container-border-color);
  border-style: solid;
  border-radius: 5px;
  border-width: 0;
  margin: 1px 3px 1px 1px;
  display: flex;
  justify-content: flex-start;
  align-items: center;

  &.selected {
    background-color: var(--current-workspace-selected-row-color);
  }

  &:hover {
    background-color: var(--current-workspace-hovered-row-color);
  }
}


.sqtm-core-container-capsule {
  border-width: 1px;

  .name {
    font-size: 14px;
    font-weight: 500;
  }
}

.sqtm-core-external-capsule {
  width: 100%;
  height: 30px;
  margin: 1px 3px 1px 1px;
  display: flex;
  justify-content: flex-start;
  align-items: center;

  .capsule-left-color-indicator {
    border-color: var(--container-border-color);
    border-style: solid;
    border-width: 1px 0 1px 0;
    border-top-left-radius: 5px;
    border-bottom-left-radius: 5px;
    width: 6px;
  }

  .inner-capsule {
    border-color: var(--container-border-color);
    border-style: solid;
    border-width: 1px 1px 1px 0;
    border-top-right-radius: 5px;
    border-bottom-right-radius: 5px;
    background-color: white;
    display: flex;
    justify-content: flex-start;
    align-items: center;

    &:hover {
      background-color: var(--current-workspace-hovered-row-color);
    }

    &.selected {
      background-color: var(--current-workspace-selected-row-color);
    }
  }
}

.sqtm-core-capsules-container {
  display: flex;
  flex-wrap: wrap;
  align-items: flex-end;

  > * {
    margin-right: 5px;
    margin-top: 10px;
  }
}


::ng-deep .hide-nz-select-border-override {
  .ant-select-selector {
    border-style: none !important;
  }
}

.sqtm-core-centered-message {
  align-items: center;
  justify-content: center;
  color: var(--label-color);
}


// for overlay, don't forget to add position:relative to the parent
.sqtm-core-async-overlay {
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: rgba(189, 189, 189, 0.7);
  user-select: none;
  z-index: 1000;
  font-size: 30px;
  position: absolute;
  top: 0;
  left: 0;
}

.sqtm-core-multi-research-field {
  width: 200px;
  display: flex;
}

.sqtm-core-font-dialog-title {
  color: var(--label-color);
  font-weight: 500;
  font-size: 18px;
}

/* Gherkin CSS */

.scenario-keyword {
  font-weight: bold;
  font-size: 105%;
}

.scenario-description {
  font-style: italic;
}

.step-doc-string {
  font-style: italic;
  color: #f5f5f5;
}

.step-keyword {
  font-weight: bold;
}

.step-keyword-given {
  color: #008800;
}

.step-keyword-when {
  color: #0000FF;
}

.step-keyword-then {
  color: #660066;
}

.step-table-tr {
  border-bottom: 1px solid;
}

.step-table-tr:nth-child(even) {
  background-color: #f2f2f2;
}

.step-table-td {
  border-bottom: 1px solid;
}

.automation-workspace-grid-container {
  padding: 10px 10px 10px 0;
}


.automation-workspace-main-title {
  display: block;
  font-size: 20px;
  font-weight: 600;
  color: var(--current-workspace-main-color);
  margin-top: 8px;
}

.automation-workspace-secondary-title {
  display: block;
  font-size: 18px;
  font-weight: 600;
  color: var(--current-workspace-main-color);
}

.automation-workspace-grid {
  overflow: hidden;
  width: 100%;
  height: 100%;
  display: block;
}

.automation-workspace-grid-toolbar {
  margin: 8px 0 8px 20px;
  font-size: 18px;

  i {
    margin: 0 6px;
  }
}

.banner {
  background-color: #fffbe6;
  border-bottom: #ffe58f 1px solid;
  min-height: 30px;
  max-height: 60px;
  padding: 4px;

  .message {
    margin: auto 6px;

    i {
      margin-right: 4px;
    }
  }

  .detail-link {
    text-decoration: underline;
    cursor: pointer;
  }
}

.vertical-scroll {
  overflow-y: auto;
  overflow-x: hidden;
}

.m-b-auto {
  margin-bottom: auto;
}

.m-t-auto {
  margin-top: auto;
}

.m-l-auto {
  margin-left: auto;
}

.m-r-auto {
  margin-right: auto;
}

.m-auto {
  margin: auto;
}

.overflow-auto {
  overflow: auto;
}

.overflow-y-hidden {
  overflow-y: hidden;
}

.overflow-y-auto {
  overflow-y: auto;
}

.overflow-x-auto {
  overflow-x: auto;
}

.overflow-x-hidden {
  overflow-x: hidden
}

.panel-title {
  font-weight: 600;
  font-size: 18px;
  color: var(--current-workspace-main-color);
}

.panel-buttons {
    display: flex;
    align-items: center;

    & > * {
        padding-left: 5px;
        padding-right: 5px;
    }

    .buttons-separator {
        padding: 0;
        margin: 0 8px;
        border-right: 1px solid rgba(0, 0, 0, 0.25);
        width: 1px;
        height: 23px;
    }
}

.view-title {
  font-weight: 600;
  font-size: 18px;
  color: var(--current-workspace-main-color);
  margin: 0 0 10px;
}

.space-between {
  justify-content: space-between;
}

.align-items-center {
  align-items: center;
}

.inline {
  display: inline;
}

.text-align-center {
  text-align: center;
}

.text-align-left {
  text-align: left;
}

.text-align-right {
  text-align: right;
}

.m-auto-0 {
  margin: auto 0;
}

.m-auto-30 {
  margin: auto 30px;
}

.align-self-center {
  align-self: center;
}

.align-self-end {
  align-self: end;
}

.block-border {
  border-left: 2px solid var(--container-border-color);
}

.txt-bold {
  font-weight: bold;
}

.text-decoration-none {
  text-decoration: none;
}

.erlenmeyer-icon {
  font-size: 20px;
  padding-left: 5px;
}

.align-content-center {
  align-content: center;
}

.display-block {
  display: block;
}

// Remove bottom margin for last paragraph in configurable banner
sqtm-core-configurable-banner .wrapper > p:last-child {
  margin-bottom: 0;
}

.align-items-flex-end {
  align-items: flex-end;
}

.flex-grow {
  flex-grow: 1;
}

.information-grid-server {
  display: grid;
  grid-template-columns: 1fr 2fr 1fr minmax(0, 2fr);
  grid-column-gap: 1%;
  grid-row-gap: 10px;
  align-items: center;
  margin-bottom: 10px;
}

.url-link-server {
  display: flex;
  align-items: center;
}

.col-spacer-server {
  grid-column-start: 1;
  grid-column-end: 3;
}

.server-information-grid {
  display: grid;
  grid-column-gap: 1%;
  grid-row-gap: 10px;
  align-items: center;
  margin-bottom: 10px;
}
.grid-2-server {
  grid-template-columns: minmax(0, 1fr) minmax(0, 5fr);
}
.section-title {
  text-transform: uppercase;
  color: var(--current-workspace-main-color);
  font-size: 12px;
  font-weight: 600;
}

.overflow-break-work {
  overflow-wrap: break-word;
}

.height-fit-content {
  height: fit-content;
}

.content-body {
  overflow-y: hidden;
  border: solid 1px var(--background-color);
  height: 100%;
  padding-left: 18px;
}

.multi-view-title {
  font-weight: 600;
  font-size: 20px;
}

.width-40 {
  width: 40px;
}

.m-y-auto {
  margin-top: auto;
  margin-bottom: auto;
}

.enable-user-selection {
  user-select: text;
}

.no-border {
  border: none;
}
